---
jupytext:
  text_representation:
    extension: .md
    format_name: myst
    format_version: 0.13
    jupytext_version: 1.15.1
kernelspec:
  display_name: Python 3 (ipykernel)
  language: python
  name: python3
---

# Semaine 1: Introduction à l'informatique et premiers programmes

## [Cours](cours.md)

## [TD : Notion d'algorithme](TD.md)

## TP : prise en main, premiers programmes avec laby

+++

**Tout exercice non marqué d'un ♣ est à terminer pour la semaine prochaine.**

+++

### Introduction

Dans ce premier TP vous allez écrire de petits programmes de façon
ludique (faire sortir une fourmi d'un labyrinthe, etc), occasion d'avoir
un premier contact avec quelques constructions (conditionnelles,
boucles, fonctions) que nous approfondirons par la suite.

![image](media/laby3a.png)

Pour cela, nous utiliserons des *feuilles d'exercices interactives
`Jupyter`*. `Jupyter` est une application web qui permet de programmer
interactivement dans de nombreux langages (`Python`, `C++`, ...), un
peu comme une super calculatrice, et de rédiger des documents
interactifs.

+++

### Exercice 1 : Premiers pas avec Jupyter

1.  Ouvrez la feuille de travail
	[0a-prise-en-main-jupyter.md](0a-prise-en-main-jupyter.md).

2.  Suivez les instructions qu'elle contient.

+++

### Exercice 2 : Dépôt de votre travail

+++

1.  Revenez au tableau de bord du cours

    Indication : recherchez l'onglet ![tableau de bord](media/tableau_de_bord.png);
    si vous l'avez fermé, revenez à la
	[page d'accès au matériel pédagogique](https://Nicolas.Thiery.name/Enseignement/Info111/ComputerLab/)
	et suivez les instructions.

2.  Vérifiez le choix du groupe
3.  Déposez le devoir `Semaine1`
4.  Consultez le dépôt `Semaine1` sur GitLab.
5.  Votre travail est maintenant sauvegardé et vous pouvez y accéder
    depuis chez vous.

<!-- TODO : consultation de la correction automatique !-->

Pensez à déposer régulièrement votre travail, et systématiquement à la
fin du TP pour que tout ce que vous avez fait soit bien sauvegardé.

+++

### Exercice 3 : Premiers programmes en jouant

+++

### Exercice 4 : À faire pour la semaine prochaine

Deux heures supplémentaires de `Laby`! Vous pouvez par exemple
utiliser un ordinateur en salle libre-service de l'université (salle
215, sauf si cours) ou le service JupyterHub@Paris-Saclay. Dans tous
les cas, assurez-vous de télécharger le devoir en début de chaque
séance et de le déposer régulièrement ensuite. En particulier, le
déposer avant de vous déconnecter pour que tout ce que vous avez fait
soit bien sauvegardé.

